unit RightLeft;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
TWRLPos = (rlRight, rlLeft);
TWRLCS = (rlLight,rlDark);
TWRLButstyle = (rlRectangle,rlEllipse);

  TRightLeft = class(TCustomControl)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    butpos:Twrlpos;
    butcol:twrlcs;
    anim:Boolean;
    butstyle:TWRLButstyle;

   Hand:String;
  published
    { Published declarations }

  Property Handed:TwRLPOS read butpos write butpos default rlright;
  Property ColorStyle:Twrlcs read butcol write butcol default rlLight;
  Property ButtonStyle :TWRLButstyle read butstyle write butstyle;

    property Color;
    property Width;
    property OnClick;
    Property Enabled;
    Property Visible;
    Property Animate:Boolean read anim write anim ;
    procedure Paint;override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('WAISS', [TRightLeft]);
end;

//------------------------------------------------------------------------------
procedure TrightLeft.Paint;

var f,texwid,st:integer;
ptext:String;
dtext,stf: integer; // position to draw text


begin
texwid :=  Canvas.TextWidth(' Right ');
 f := width - texwid+2 ;// check how much place is available for button
                                         //  after right for the button
 if f <4 then width := texwid + 5; //make a mandatory width
                                     //width to fit button
 f:=f-2;// so that the last line is see able
 if handed = rlLeft then
    begin
         st := 1;
         ptext := ' Left ';
         dtext := (width - (texwid)) +1
     end
    else
    begin
         st := texwid+1; // set strting point for button
         dtext := 0;
         ptext := ' Right ';
 end;
 // start drawing button

 stf := (st+f)-1;

with canvas do
begin
if buttonstyle = rlRectangle then
begin
canvas.brush.color:=color;
 canvas.fillrect(cliprect);
 textout(dtext,1,ptext);
  stf := (st+f)-1;
pen.color := clwhite; // highlight color
moveto(st,1);
lineto(stf-2,1);// draw top line
moveto(st,1);

lineto(st,height-2); //draw white side line;
pen.color := clGray;
Lineto(stf-2,height-2);
Lineto(stf-2,1);
pen.color:=clblack;// draw shadow
moveto(st,height);
lineto((stf)-1,height-1);
lineto((stf)-1,0);
pen.color:= clsilver;
moveto(st-1,0);
lineto(stf,0);
moveto(st-1,0);
lineto(st-1,height-1);


 moveto(st-1,height-1); //draw white side line;
pen.color := clblack;
Lineto(stf-1,height-1);
Lineto(stf-1,1);
brush.color:=clbtnface;
fillrect(Rect(st+1,2,stf-1,height-2))
end
// -------------- break ---- start elipse
else
begin

stf:=stf-1;// so that the black will show on the control
canvas.brush.color:=color;
 canvas.fillrect(cliprect);
 textout(dtext,1,ptext);
pen.color := clblack;
brush.color := clblack;
ellipse(st+3,4,stf,height);
pen.color := clSilver;
brush.color := clSilver;
ellipse(st-1,0,stf-3,height-4);

pen.color := clWhite;
brush.color := clWhite;
ellipse(st,1,stf-2,height-3);

pen.color := clgray;
brush.color := clgray;
ellipse(st+2,3,stf,height-1);
pen.color := clsilver;
brush.color := clsilver;
ellipse(st+1,2,stf-1,height-2);
 end;
end;
end;
//------------------------------------------------------------------------------
procedure TRightLeft.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
 begin

 if handed = rlLeft then
 begin
      handed := rlRight;
      hand:='Right';
 end
 else
 begin
      handed := rlLeft ;
      hand := 'Left';
 end;
 paint;
 inherited click;
end;

//------------------------------------------------------------------------------

procedure TRightLeft.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);

  var texwid:integer;
  sp1,sp2:integer;


  begin
 texwid := width - (Canvas.TextWidth(' Right ')+2);
 sp1 := (width div 2)-texwid div 2; // find start point for graphic
 sp2 := width - sp1; // find end point

 with canvas do
begin
canvas.brush.color:=color;
 canvas.fillrect(cliprect);

 if buttonstyle = rlRectangle then
 begin
pen.color := clwhite; // highlight color
moveto(sp1,1);
lineto(sp2,1);// draw top line
moveto(sp1,1);

lineto(sp1,height-2); //draw white side line;
pen.color := clGray;
Lineto(sp2,height-2);
Lineto(sp2,1);
pen.color:=clblack;// draw shadow
moveto(sp1+1,height-1);
lineto(sp2+1,height-1);
lineto(sp2+1,1);
pen.color:= clsilver;
moveto(sp1,0);
lineto(sp2,0);
moveto(sp1,0);
lineto(sp1,height-1);

brush.color:=clbtnface;
fillrect(Rect(sp1+1,2,sp2,height-2))
end
   else
begin
pen.color := clblack;
brush.color := clblack;
ellipse(sp1+3,4,sp2,height);
pen.color := clSilver;
brush.color := clSilver;
ellipse(sp1+1,0,sp2-3,height-4);

pen.color := clWhite;
brush.color := clWhite;
ellipse(sp1,1,sp2-2,height-3);

pen.color := clgray;
brush.color := clgray;
ellipse(sp1+2,3,sp2,height-1);
pen.color := clsilver;
brush.color := clsilver;
ellipse(sp1+1,2,sp2-1,height-2);

end;

 end;
 end;

end.
